<?php
//----------------------------------------------//
// PHP画像カウンタ
// 画像変換サンプル"「はじめてのPHP5」オライリー・ジャパン"より
//----------------------------------------------//
// 設定
//----------------------------------------------//
$ipCheck = 1;  // IPチェックを行うかどうか（1＝行う、0＝行わない）
$font = 5;  // 文字の大きさ（1～5）
$logfile = dirname(__FILE__).'/count.log';  // ログファイル
//----------------------------------------------//
// カウント処理
//----------------------------------------------//
// 初期作成
if (!file_exists($logfile))
{
    touch($logfile);
}
// ファイルオープン
$FH = fopen($logfile, 'r+') or die($logfile."が開けません");
flock($FH, LOCK_EX);
// カウント数（1行目）とIP（2行目）を取得
$getCount = rtrim(fgets($FH));
$getIp = rtrim(fgets($FH));
// nullの場合カウント数を0に
if($getCount == null)
{
    $getCount = 0;
}
// IP判定
if($getIp != $_SERVER['REMOTE_ADDR'] || !$ipCheck)
{
    $getCount ++;
    $getIp = $_SERVER['REMOTE_ADDR'];
}
// ファイル書き込み
rewind($FH);
fwrite($FH, $getCount."\n".$getIp);
fclose($FH);
//----------------------------------------------//
// 画像処理
//----------------------------------------------//
// 画像サイズ設定
$imageHeight = intval(imageFontHeight($font) * 1.2);
$imageWidth = intval(strlen($getCount) * imageFontWidth($font) * 1.5);

// 画像を生成
$image = imageCreate($imageWidth, $imageHeight);

// 各色設定
$backColor = imageColorAllocate($image, 255, 255, 255);
$textColor = imageColorAllocate($image, 0, 0, 255);
$rectColor =imageColorAllocate($image, 255, 255, 255);

// 文字の位置
$x = ($imageWidth - (imageFontWidth($font) * strlen($getCount))) / 2;
$y = ($imageHeight - imageFontHeight($font)) / 2;

// 文字を書く
imageString($image, $font, $x ,$y ,$getCount ,$textColor);
// 境界線を書く
imageRectangle($image, 0, 0, imageSX($image) - 1, imageSY($image) - 1, $rectColor);

// 表示
header('Content-Type: image/png');
imagePNG($image);
imageDestroy($image);
//----------------------------------------------//
?>
